/*****************************************************************************
 * (c) Copyright 2010, Freescale Semiconductor Inc.
 * ALL RIGHTS RESERVED.
 ***************************************************************************//*!
 * @file      fll.c
 * @author    R55013
 * @version   1.0.1.0
 * @date      Mar-8-2011
 * @brief     FLL driver implementation.
 * @par       Driver example:
 * @include   src\projects\fll_test\fll_test.c 
 * @par       Interrupt vector definition(s):
 * @include   src\projects\fll_test\isr.h		
 ******************************************************************************/
#include "common.h"
#include "fll.h"
#include <MK10F12.H>

/******************************************************************************
 * macro definitions                                                          *
 ******************************************************************************/
#define WAIT_FOR_STATUS_FLAG(reg, name1, name2, name3)                                 \
{                                                                             \
  while (((MCG->S&MCG_S_##name3##_MASK)>>MCG_S_##name3##_SHIFT)!=              \
    ((reg##->##name1&##reg##_##name1##_##name2##_MASK)>>##reg##_##name1##_##name2##_SHIFT));                 \
}

/******************************************************************************
 * Public functions definitions                                               *
 ******************************************************************************/
/***************************************************************************//*!
 * @brief   FLL initialization function.
 * @param   fll     - FLL configuration structure passed by value:
 *                    FLL_MODULE_CONFIG_FEI_20_25MHZ,\n
 *                    FLL_MODULE_CONFIG_FEI_24MHZ,\n
 *                    FLL_MODULE_CONFIG_FEI_40_50MHZ,\n
 *                    FLL_MODULE_CONFIG_FEI_48MHZ,\n
 *                    FLL_MODULE_CONFIG_FEI_60_75MHZ,\n
 *                    FLL_MODULE_CONFIG_FEI_72MHZ,\n
 *                    FLL_MODULE_CONFIG_FEI_80_100MHZ,\n
 *                    FLL_MODULE_CONFIG_FEE_96MHZ,\n
 *                    FLL_MODULE_CONFIG_FEE_24MHZ,\n
 *                    FLL_MODULE_CONFIG_FEE_48MHZ,\n
 *                    FLL_MODULE_CONFIG_FEE_72MHZ,\n
 *                    FLL_MODULE_CONFIG_FEE_96MHZ.\n 
 * @return  none
 * @note    Implemented as function call.
 ******************************************************************************/
#pragma diag_suppress=Pa082
void FLL_Init (tFLL fll)
{    
//  MCG->C2 = fll.C2;  
//  MCG->C1 = fll.C1;
//  WAIT_FOR_STATUS_FLAG (MCG, C1, IREFS, IREFST); 
//  MCG->C6 = fll.C6;    
//  WAIT_FOR_STATUS_FLAG (MCG, C1, CLKS, CLKST);
//  WAIT_FOR_STATUS_FLAG (MCG, C2, IRCS, IRCST);
//  MCG->C4 = fll.C4; 
//  while ((MCG->C4 && MCG_C4_DRST_DRS_MASK) != (fll.C4 && MCG_C4_DRST_DRS_MASK));   
}
/******************************************************************************
 * End of module                                                              *
 ******************************************************************************/
