/*****************************************************************************
 * (c) Copyright 2010, Freescale Semiconductor Inc.
 * ALL RIGHTS RESERVED.
 ***************************************************************************//*!
 * @file      fll.h
 * @author    R55013
 * @version   1.0.1.0
 * @date      Mar-8-2011
 * @brief     FLL driver header file.
 ******************************************************************************/
#ifndef __FLL_H
#define __FLL_H 
 
/******************************************************************************
 * definition configuration structure                                         *
 ******************************************************************************/
typedef struct { uint8 C1, C2, C4, C6; } tFLL;

/******************************************************************************
 * default configurations                                                     *
 ******************************************************************************/
/* MCG engage internal FLL modes                                              */ 
#define FLL_MODULE_CONFIG_FEI_20_25MHZ                                        \
(tFLL){                                                                       \
/* C1 */ SET(MCG_C1_CLKS(0x00))|SET(MCG_C1_FRDIV(0x00))|                      \
         SET(MCG_C1_IREFS_MASK)|CLR(MCG_C1_IRCLKEN_MASK)|                     \
         CLR(MCG_C1_IREFSTEN_MASK),                                           \
/* C2 */ CLR(MCG_C2_RANGE(0x00))|CLR(MCG_C2_HGO_MASK)|                        \
         CLR(MCG_C2_EREFS_MASK)|CLR(MCG_C2_LP_MASK)|CLR(MCG_C2_IRCS_MASK),    \
/* C4 */ CLR(MCG_C4_DMX32_MASK)|SET(MCG_C4_DRST_DRS(0x00)),                   \
/* C6 */ CLR(MCG_C6_LOLIE_MASK)|CLR(MCG_C6_PLLS_MASK)|CLR(MCG_C6_CME_MASK)|   \
         CLR(MCG_C6_VDIV(0x00))                                               \
}

#define FLL_MODULE_CONFIG_FEI_24MHZ                                           \
(tFLL){                                                                       \
/* C1 */ SET(MCG_C1_CLKS(0x00))|SET(MCG_C1_FRDIV(0x00))|                      \
         SET(MCG_C1_IREFS_MASK)|CLR(MCG_C1_IRCLKEN_MASK)|                     \
         CLR(MCG_C1_IREFSTEN_MASK),                                           \
/* C2 */ CLR(MCG_C2_RANGE(0x00))|CLR(MCG_C2_HGO_MASK)|                        \
         CLR(MCG_C2_EREFS_MASK)|CLR(MCG_C2_LP_MASK)|CLR(MCG_C2_IRCS_MASK),    \
/* C4 */ SET(MCG_C4_DMX32_MASK)|SET(MCG_C4_DRST_DRS(0x00)),                   \
/* C6 */ CLR(MCG_C6_LOLIE_MASK)|CLR(MCG_C6_PLLS_MASK)|CLR(MCG_C6_CME_MASK)|   \
         CLR(MCG_C6_VDIV(0x00))                                               \
}

#define FLL_MODULE_CONFIG_FEI_40_50MHZ                                        \
(tFLL){                                                                       \
/* C1     */ SET(MCG_C1_CLKS(0x00))|SET(MCG_C1_FRDIV(0x00))|                  \
             SET(MCG_C1_IREFS_MASK)|CLR(MCG_C1_IRCLKEN_MASK)|                 \
             CLR(MCG_C1_IREFSTEN_MASK),                                       \
/* C4     */ CLR(MCG_C4_DMX32_MASK)|SET(MCG_C4_DRST_DRS(0x01)),               \
/* C6     */ CLR(MCG_C6_LOLIE_MASK)|CLR(MCG_C6_PLLS_MASK)|                    \
             CLR(MCG_C6_CME_MASK)|CLR(MCG_C6_VDIV(0x00))                      \
}

#define FLL_MODULE_CONFIG_FEI_48MHZ                                           \
(tFLL){                                                                       \
/* C1 */ SET(MCG_C1_CLKS(0x00))|SET(MCG_C1_FRDIV(0x00))|                      \
         SET(MCG_C1_IREFS_MASK)|CLR(MCG_C1_IRCLKEN_MASK)|                     \
         CLR(MCG_C1_IREFSTEN_MASK),                                           \
/* C2 */ CLR(MCG_C2_RANGE(0x00))|CLR(MCG_C2_HGO_MASK)|                        \
         CLR(MCG_C2_EREFS_MASK)|CLR(MCG_C2_LP_MASK)|CLR(MCG_C2_IRCS_MASK),    \
/* C4 */ SET(MCG_C4_DMX32_MASK)|SET(MCG_C4_DRST_DRS(0x01)),                   \
/* C6 */ CLR(MCG_C6_LOLIE_MASK)|CLR(MCG_C6_PLLS_MASK)|CLR(MCG_C6_CME_MASK)|   \
         CLR(MCG_C6_VDIV(0x00))                                               \
}

#define FLL_MODULE_CONFIG_FEI_60_75MHZ                                        \
(tFLL){                                                                       \
/* C1 */ SET(MCG_C1_CLKS(0x00))|SET(MCG_C1_FRDIV(0x00))|                      \
         SET(MCG_C1_IREFS_MASK)|CLR(MCG_C1_IRCLKEN_MASK)|                     \
         CLR(MCG_C1_IREFSTEN_MASK),                                           \
/* C2 */ CLR(MCG_C2_RANGE(0x00))|CLR(MCG_C2_HGO_MASK)|                        \
         CLR(MCG_C2_EREFS_MASK)|CLR(MCG_C2_LP_MASK)|CLR(MCG_C2_IRCS_MASK),    \
/* C4 */ CLR(MCG_C4_DMX32_MASK)|SET(MCG_C4_DRST_DRS(0x02)),                   \
/* C6 */ CLR(MCG_C6_LOLIE_MASK)|CLR(MCG_C6_PLLS_MASK)|CLR(MCG_C6_CME_MASK)|   \
         CLR(MCG_C6_VDIV(0x00))                                               \
}

#define FLL_MODULE_CONFIG_FEI_72MHZ                                           \
(tFLL){                                                                       \
/* C1 */ SET(MCG_C1_CLKS(0x00))|SET(MCG_C1_FRDIV(0x00))|                      \
         SET(MCG_C1_IREFS_MASK)|CLR(MCG_C1_IRCLKEN_MASK)|                     \
         CLR(MCG_C1_IREFSTEN_MASK),                                           \
/* C2 */ CLR(MCG_C2_RANGE(0x00))|CLR(MCG_C2_HGO_MASK)|                        \
         CLR(MCG_C2_EREFS_MASK)|CLR(MCG_C2_LP_MASK)|CLR(MCG_C2_IRCS_MASK),    \
/* C4 */ SET(MCG_C4_DMX32_MASK)|SET(MCG_C4_DRST_DRS(0x02)),                   \
/* C6 */ CLR(MCG_C6_LOLIE_MASK)|CLR(MCG_C6_PLLS_MASK)|CLR(MCG_C6_CME_MASK)|   \
         CLR(MCG_C6_VDIV(0x00))                                               \
}

#define FLL_MODULE_CONFIG_FEI_80_100MHZ                                       \
(tFLL){                                                                       \
/* C1 */ SET(MCG_C1_CLKS(0x00))|SET(MCG_C1_FRDIV(0x00))|                      \
         SET(MCG_C1_IREFS_MASK)|CLR(MCG_C1_IRCLKEN_MASK)|                     \
         CLR(MCG_C1_IREFSTEN_MASK),                                           \
/* C2 */ CLR(MCG_C2_RANGE(0x00))|CLR(MCG_C2_HGO_MASK)|                        \
         CLR(MCG_C2_EREFS_MASK)|CLR(MCG_C2_LP_MASK)|CLR(MCG_C2_IRCS_MASK),    \
/* C4 */ CLR(MCG_C4_DMX32_MASK)|SET(MCG_C4_DRST_DRS(0x03)),                   \
/* C6 */ CLR(MCG_C6_LOLIE_MASK)|CLR(MCG_C6_PLLS_MASK)|CLR(MCG_C6_CME_MASK)|   \
         CLR(MCG_C6_VDIV(0x00))                                               \
}

#define FLL_MODULE_CONFIG_FEI_96MHZ                                           \
(tFLL){                                                                       \
/* C1 */ SET(MCG_C1_CLKS(0x00))|SET(MCG_C1_FRDIV(0x00))|                      \
         SET(MCG_C1_IREFS_MASK)|CLR(MCG_C1_IRCLKEN_MASK)|                     \
         CLR(MCG_C1_IREFSTEN_MASK),                                           \
/* C2 */ CLR(MCG_C2_RANGE(0x00))|CLR(MCG_C2_HGO_MASK)|                        \
         CLR(MCG_C2_EREFS_MASK)|CLR(MCG_C2_LP_MASK)|CLR(MCG_C2_IRCS_MASK),    \
/* C4 */ SET(MCG_C4_DMX32_MASK)|SET(MCG_C4_DRST_DRS(0x03)),                   \
/* C6 */ CLR(MCG_C6_LOLIE_MASK)|CLR(MCG_C6_PLLS_MASK)|CLR(MCG_C6_CME_MASK)|   \
         CLR(MCG_C6_VDIV(0x00))                                               \
}

/* MCG engage external FLL modes                                              */
#define FLL_MODULE_CONFIG_FEE_24MHZ                                           \
(tFLL){                                                                       \
/* C1 */ SET(MCG_C1_CLKS(0x00))|SET(MCG_C1_FRDIV(0x00))|                      \
         CLR(MCG_C1_IREFS_MASK)|CLR(MCG_C1_IRCLKEN_MASK)|                     \
         CLR(MCG_C1_IREFSTEN_MASK),                                           \
/* C2 */ CLR(MCG_C2_RANGE(0x00))|CLR(MCG_C2_HGO_MASK)|                        \
         CLR(MCG_C2_EREFS_MASK)|CLR(MCG_C2_LP_MASK)|CLR(MCG_C2_IRCS_MASK),    \
/* C4 */ SET(MCG_C4_DMX32_MASK)|SET(MCG_C4_DRST_DRS(0x00)),                   \
/* C6 */ CLR(MCG_C6_LOLIE_MASK)|CLR(MCG_C6_PLLS_MASK)|CLR(MCG_C6_CME_MASK)|   \
         CLR(MCG_C6_VDIV(0x00))                                               \
}

#define FLL_MODULE_CONFIG_FEE_48MHZ                                           \
(tFLL){                                                                       \
/* C1 */ SET(MCG_C1_CLKS(0x00))|SET(MCG_C1_FRDIV(0x00))|                      \
         CLR(MCG_C1_IREFS_MASK)|CLR(MCG_C1_IRCLKEN_MASK)|                     \
         CLR(MCG_C1_IREFSTEN_MASK),                                           \
/* C2 */ CLR(MCG_C2_RANGE(0x00))|CLR(MCG_C2_HGO_MASK)|                        \
         CLR(MCG_C2_EREFS_MASK)|CLR(MCG_C2_LP_MASK)|CLR(MCG_C2_IRCS_MASK),    \
/* C4 */ SET(MCG_C4_DMX32_MASK)|SET(MCG_C4_DRST_DRS(0x01)),                   \
/* C6 */ CLR(MCG_C6_LOLIE_MASK)|CLR(MCG_C6_PLLS_MASK)|CLR(MCG_C6_CME_MASK)|   \
         CLR(MCG_C6_VDIV(0x00))                                               \
}

#define FLL_MODULE_CONFIG_FEE_72MHZ                                           \
(tFLL){                                                                       \
/* C1 */ SET(MCG_C1_CLKS(0x00))|SET(MCG_C1_FRDIV(0x00))|                      \
         CLR(MCG_C1_IREFS_MASK)|CLR(MCG_C1_IRCLKEN_MASK)|                     \
         CLR(MCG_C1_IREFSTEN_MASK),                                           \
/* C2 */ CLR(MCG_C2_RANGE(0x00))|CLR(MCG_C2_HGO_MASK)|                        \
         CLR(MCG_C2_EREFS_MASK)|CLR(MCG_C2_LP_MASK)|CLR(MCG_C2_IRCS_MASK),    \
/* C4 */ SET(MCG_C4_DMX32_MASK)|SET(MCG_C4_DRST_DRS(0x02)),                   \
/* C6 */ CLR(MCG_C6_LOLIE_MASK)|CLR(MCG_C6_PLLS_MASK)|CLR(MCG_C6_CME_MASK)|   \
         CLR(MCG_C6_VDIV(0x00))                                               \
}

#define FLL_MODULE_CONFIG_FEE_96MHZ                                           \
(tFLL){                                                                       \
/* C1 */ SET(MCG_C1_CLKS(0x00))|SET(MCG_C1_FRDIV(0x00))|                      \
         CLR(MCG_C1_IREFS_MASK)|CLR(MCG_C1_IRCLKEN_MASK)|                     \
         CLR(MCG_C1_IREFSTEN_MASK),                                           \
/* C2 */ CLR(MCG_C2_RANGE(0x00))|CLR(MCG_C2_HGO_MASK)|                        \
         CLR(MCG_C2_EREFS_MASK)|CLR(MCG_C2_LP_MASK)|CLR(MCG_C2_IRCS_MASK),    \
/* C4 */ SET(MCG_C4_DMX32_MASK)|SET(MCG_C4_DRST_DRS(0x03)),                   \
/* C6 */ CLR(MCG_C6_LOLIE_MASK)|CLR(MCG_C6_PLLS_MASK)|CLR(MCG_C6_CME_MASK)|   \
         CLR(MCG_C6_VDIV(0x00))                                               \
}

/******************************************************************************
 * data type definitions                                                      *
 ******************************************************************************/

/******************************************************************************
 * command definitions                                                        *
 ******************************************************************************/
#pragma diag_suppress=Pa082
/***************************************************************************//*!
 * @brief   Macro sets slow clock trim value (SCTRIM and SCFTRIM bits).
 *          Increasing the trim value increases the period, and decreasing 
 *          the value decreases the period. Upon reset this value is loaded with
 *          a factory trim value. 
 * @param   x - 9-bit trim value in range <0,511> 
 * @return  none
 * @note    Implemented as inlined macro.
 ******************************************************************************/
#define FLL_SetSlowClockTrimVal(x)                                            \
{                                                                             \
  MCG->C3 = (0xff & (x>>1));                                                   \
  REG_SetVal(MCG->C4,MCG_C4_SCFTRIM_MASK,(x&0x01),MCG_C4_SCFTRIM_SHIFT);       \
}

/***************************************************************************//*!
 * @brief   Macro reads slow clock trim values (SCTRIM and SCFTRIM bits). 
 * @return  9-bit trim value in range <0,511>
 * @note    Implemented as inlined macro.
 ******************************************************************************/
#define FLL_GetSlowClockTrimVal()   ((((uint16)MCG->C3)<<1)|(uint16)(MCG_C4&0x01))

/***************************************************************************//*!
 * @brief   Macro sets fast clock trim value (FCTRIM bits). Increasing the trim
 *          value increases the period, and decreasing the value decreases 
 *          the period. Upon reset this value is loaded with a factory trim value. 
 * @param   x - 4-bit trim value in range <0,15> 
 * @return  none
 * @note    Implemented as inlined macro.
 ******************************************************************************/
#define FLL_SetFastClockTrimVal(x)                                            \
{                                                                             \
  REG_SetVal(MCG->C4,MCG_C4_FCTRIM_MASK,(x&0x0f),MCG_C4_FCTRIM_SHIFT);         \
}

/***************************************************************************//*!
 * @brief   Macro reads fast clock trim values (FCTRIM bits). 
 * @return  4-bit trim value in range <0,15>
 * @note    Implemented as inlined macro.
 ******************************************************************************/
#define FLL_GetFastClockTrimVal() ((MCG->C4&MCG_C4_FCTRIM_MASK)>>MCG_C4_FCTRIM_SHIFT)

/***************************************************************************//*!
 * @brief   Macro enables/disables internal reference clock for use as MCGIRCLK. 
 * @param   x - 1 (MCGIRCLK active) 
 * @param   x - 0 (MCGIRCLK inactive)
 * @return  none
 * @note    Implemented as inlined macro.
 ******************************************************************************/
#define FLL_CtrlIRCLKEN(x)                                                    \
{                                                                             \
  REG_SetVal(MCG->C1,MCG_C1_IRCLKEN_MASK,(x&0x01),MCG_C1_IRCLKEN_SHIFT);       \
}

/***************************************************************************//*!
 * @brief   Macro controls whether or not the internal reference clock remains 
 *          enabled when the MCG enters Stop mode. 
 * @param   x - 1 (Internal reference clock is enabled in Stop mode if IRCLKEN 
 *                 is set or if MCG is in FEI, FBI, or BLPI modes before entering 
 *                 Stop mode.) 
 * @param   x - 0 (Internal reference clock is disabled in Stop mode)
 * @return  none
 * @note    Implemented as inlined macro.
 ******************************************************************************/
#define FLL_CtrlIREFSTEN(x)                                                   \
{                                                                             \
  REG_SetVal(MCG->C1,MCG_C1_IREFSTEN_MASK,(x&0x01),MCG_C1_IREFSTEN_SHIFT);     \
}

/***************************************************************************//*!
 * @brief   Macro controls whether the FLL (or PLL) is disabled in BLPI and 
 *          BLPE modes. In FBE or PBE modes, calling setting LP bit to 1 will 
 *          transition the MCG into BLPE mode; in FBI mode, setting this bit 
 *          to 1 will transition the MCG into BLPI mode. In any other MCG mode, 
 *          LP bit has no affect.
 * @param   x - 1 (FLL or PLL is disabled in bypass modes) 
 * @param   x - 0 (FLL or PLL is not disabled in bypass modes)
 * @return  none
 * @note    Implemented as inlined macro.
 ******************************************************************************/
#define FLL_CtrlLP(x)                                                         \
{                                                                             \
  REG_SetVal(MCG->C2,MCG_C2_LP_MASK,(x&0x01),MCG_C2_LP_SHIFT);                 \
}

/***************************************************************************//*!
 * @brief   Macro controls external clock monitor. Determines if a reset 
 *          request is made following a loss of external clock indication. 
 *          The CME bit should only be set to a logic 1 when either the MCG is 
 *          in an operational mode that uses the external clock (FEE, FBE, PEE, 
 *          PBE, or BLPE) or the external reference is enabled. Whenever the 
 *          CME bit is set to a logic 1, the value of the RANGE bits in the C2 
 *          register should not be changed. CME bit should be set to a logic 0
 *          before the MCG enters Stop mode. 
 *          Otherwise, a reset request may occur while in Stop mode.
 * @param   x - 1 (Generate a reset request on loss of external clock) 
 * @param   x - 0 (External clock monitor is disabled.)
 * @return  none
 * @note    Implemented as inlined macro.
 ******************************************************************************/
#define FLL_CtrlCME(x)                                                        \
{                                                                             \
  REG_SetVal(MCG->C6,MCG_C6_CME_MASK,(x&0x01),MCG_C6_CME_SHIFT);               \
}

/******************************************************************************
 * public function prototypes                                                 *
 ******************************************************************************/    
extern void FLL_Init (tFLL fll);

#endif /* __FLL_H */ 