/*****************************************************************************
 * (c) Copyright 2010, Freescale Semiconductor Inc.
 * ALL RIGHTS RESERVED.
 ***************************************************************************//*!
 * @file      sim.c
 * @author    R55013
 * @version   1.0.4.0
 * @date      Mar-8-2011
 * @brief     SIM driver implementation.
 * @par       Driver example:
 * @include   vref_test\vref_test.c
 * @par       Interrupt vector definition(s):
 * @include   vref_test\isr.h		
 ******************************************************************************/
#include "common.h"
#include "sim.h"

/******************************************************************************
 * Public functions definitions                                               *
 ******************************************************************************/
 
/***************************************************************************//*!
 * @brief   SIM module initialization function.
 * @param   sim     - SIM module configuration structure passed by value:\n 
 *                    SIM_MODULE_CONFIG\n
 * @return  none
 * @note    Implemented as function call.
 ******************************************************************************/
#pragma diag_suppress=Pa082
void SIM_Init (tSIM sim)
{
    SIM->SOPT1   |= sim.SOPT1;
    SIM->SOPT2   |= sim.SOPT2;
    SIM->SOPT4   |= sim.SOPT4;
    SIM->SOPT5   |= sim.SOPT5;
    SIM->SOPT6   |= sim.SOPT6;
    SIM->SOPT7   |= sim.SOPT7;
    SIM->SCGC1   |= sim.SCGC1;
    SIM->SCGC2   |= sim.SCGC2;
    SIM->SCGC3   |= sim.SCGC3;
    SIM->SCGC4   |= sim.SCGC4;
    SIM->SCGC5   |= sim.SCGC5;
    SIM->SCGC6   |= sim.SCGC6;
    SIM->SCGC7   |= sim.SCGC7;
    SIM->CLKDIV1 |= sim.CLKDIV1;
    SIM->CLKDIV4 |= sim.CLKDIV4;
}
/******************************************************************************
 * End of module                                                              *
 ******************************************************************************/