/*****************************************************************************
 * (c) Copyright 2010, Freescale Semiconductor Inc.
 * ALL RIGHTS RESERVED.
 ***************************************************************************//*!
 * @file      vref.c
 * @author    R55013
 * @version   1.0.4.0
 * @date      Mar-8-2011
 * @brief     VREF driver implementation.
 * @par       Driver example:
 * @include   vref_test\vref_test.c 
 * @par       Interrupt vector definition(s):
 * @include   vref_test\isr.h		
 ******************************************************************************/
#include "common.h"
#include "vref.h"

/******************************************************************************
 * Public functions definitions                                               *
 ******************************************************************************/
#pragma diag_suppress=Pa082
/***************************************************************************//*!
 * @brief   VREF initialization function.
 * @param   vref    - VREF module configuration structure passed by value: 
 *                    VREF_MODULE_CONFIG,
 *                    VREF_MODULE_TIGHTREG_CONFIG,
 *                    VREF_MODULE_LOWPWRREG_CONFIG.
 * @return  none
 * @note    Implemented as function call.
 ******************************************************************************/
void VREF_Init (tVREF vref)
{     
  VREF->SC    = VREF_SC_VREFEN_MASK;   /* enable module and keep mode 0        */           
  /* check and wait until reference is stable                                 */
  if (vref.SC & VREF_SC_VREFEN_MASK)  
    while (!(VREF->SC & VREF_SC_VREFST_MASK));
  VREF->SC    = vref.SC;               /* write control register               */   
}
/******************************************************************************
 * End of module                                                              *
 ******************************************************************************/