/*****************************************************************************
 * (c) Copyright 2010, Freescale Semiconductor Inc.
 * ALL RIGHTS RESERVED.
 ***************************************************************************//*!
 * @file      vref.h
 * @author    R55013
 * @version   1.0.4.0
 * @date      Mar-8-2011
 * @brief     VREF driver header file.
 ******************************************************************************/
#ifndef __VREF_H
#define __VREF_H 
 
/******************************************************************************
 * definition configuration structure                                         *
 ******************************************************************************/
typedef struct { uint8 SC; } tVREF;

/******************************************************************************
 * Default VREF configurations                                                *
 ******************************************************************************/
#define VREF_MODULE_CONFIG            /* tight regulation mode            */  \
(tVREF){                                                                      \
/* SC      */ SET(VREF_SC_VREFEN_MASK)|SET(VREF_SC_REGEN_MASK)|               \
              SET(VREF_SC_MODE_LV(2))                                         \
}

#define VREF_MODULE_TIGHTREG_CONFIG   /* tight regulation mode            */  \
(tVREF){                                                                      \
/* SC      */ SET(VREF_SC_VREFEN_MASK)|SET(VREF_SC_REGEN_MASK)|               \
              SET(VREF_SC_MODE_LV(2))                                         \
}

#define VREF_MODULE_LOWPWRREG_CONFIG  /* low power regulation mode        */  \
(tVREF){                                                                      \
/* SC      */ SET(VREF_SC_VREFEN_MASK)|SET(VREF_SC_REGEN_MASK)|               \
              SET(VREF_SC_MODE_LV(1))                                         \
}

  
/******************************************************************************
 * public function prototypes                                                 *
 ******************************************************************************/    
extern void VREF_Init  (tVREF vref);
   
#endif /* __VREF_H */ 